ad_library {

    Forums Library - Reply Handling

    @creation-date 2002-05-17
    @author Ben Adida <ben@openforce.biz>
    @cvs-id $Id: forum-reply-procs.tcl,v 1.3 2003/01/15 03:17:05 daveb Exp $

}

namespace eval forum::notification {

    ad_proc -public get_url {
        object_id
    } {

	set object_type [db_string get_object_type {*SQL*}]
	if {[string match "forums_forum" $object_type]} {
	    set forum_id $object_id
	    set forum_p 1
	} else {
	    set forum_id [db_string get_forum_id {*SQL*}]
	    set forum_p 0
	}
	set package_url [db_string select_forums_package_url {*SQL*}]
	if {$forum_p == 1} {
	    return "${package_url}forum-view?[export_vars forum_id]"
	} else {
	    return "${package_url}message-view?[export_vars {{message_id $object_id}}]"
	}
    }

    ad_proc -public process_reply {
        reply_id
    } {
        ns_log Notice "FORUM-NOTIF: processing reply $reply_id"

        # Get the data
        notification::reply::get -reply_id $reply_id -array reply

        # Get the message information
        forum::message::get -message_id $reply(object_id) -array message
        
        # Insert the message
        forum::message::new -forum_id $message(forum_id) \
                -parent_id $message(message_id) \
                -subject $reply(subject) \
                -content $reply(content) \
                -user_id $reply(from_user)
    }
        
    
}
